﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace WpfApplication10
{
    public class Job :INotifyPropertyChanged, IDataErrorInfo
    {
        string classification = string.Empty;
        public string Classification
        {
            get { return classification; }
            set { classification = value;
            NotifyPropertyChanged("Classification");
            }
        }

        decimal salary = 0;
        public decimal Salary
        {
            get { return salary; }
            set { salary = value;
            NotifyPropertyChanged("Salary");
            }

        }

        public override string ToString()
        {
            //  return string.Format ("Customer = {0} ID = {1}", Customer, CustomerID);
            return string.Format("{0} Sal = {1}", Classification, Salary);
        }

        //public override bool Equals(object other)
        //{
        //    bool result = false;
        //    if (other is double)
        //    {
        //        double d = (double)other;
        //        if (Salary == (decimal)d)
        //        {
        //            return true;
        //        }
        //        else return false;
        //    }
        //    else
        //    {
        //        string s = string.Format("{0} Sal = {1}", Classification, Salary);
        //        if (s == other.ToString())
        //        {
        //            return true;
        //        }
        //        else return false;
        //    }

               
        //}


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


        #endregion

        #region IDataErrorInfo Members

        //public string Error
        //{
        //    get { throw new NotImplementedException(); }
        //}

        //public string this[string columnName]
        //{
        //    get { throw new NotImplementedException(); }
        //}


        public string Error
        {
            // get { throw new NotImplementedException(); }

            get { return null; }

        }

        public string this[string property]
        {
            //get { throw new NotImplementedException(); }
            get
            {
                string msg = null;
                switch (property)
                {
                    case "Classification":
                        if ((this.Classification == string.Empty))
                            msg = " classification  incorrect ";
                        break;

                    case "Salary":
                        if (this.Salary == 0)
                            msg = "you need to go to make a living";
                        break;

                    default:
                        throw new ArgumentException(
                            "Unrecognized property: " + property);
                }
                return msg;
            }


        }
        #endregion
    }
}
