﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace WpfApplication10
{
  public   class Education :INotifyPropertyChanged, IDataErrorInfo 
    {
      string school = string.Empty;
      public string School
      {
          get { return school; }
          set { school = value;
          NotifyPropertyChanged("School");
          }
      }

      string degree = string.Empty;
      public string Degree
      {
          get { return degree; }
          set { degree = value;
          NotifyPropertyChanged("Degree");
          }
      }

      public override string ToString()
      {
          //  return string.Format ("Customer = {0} ID = {1}", Customer, CustomerID);
          return string.Format("{0}  {1}", School, Degree);
      }

      #region INotifyPropertyChanged Members

      public event PropertyChangedEventHandler PropertyChanged;
      private void NotifyPropertyChanged(String info)
      {
          if (PropertyChanged != null)
          {
              PropertyChanged(this, new PropertyChangedEventArgs(info));
          }
      }

      #endregion

      #region IDataErrorInfo Members

      public string Error
      {
         // get { throw new NotImplementedException(); }

          get { return null; }

      }

      public string this[string property]
      {
//get { throw new NotImplementedException(); }
          get
          {
              string msg = null;
              switch (property)
              {
                  case "Degree":
                      if ((this.Degree != "bs" ) && (this.Degree != "as"))
                          msg = "dgree is incorrect ";
                      break;

                  case "School":
                      if (this.School == string.Empty)
                          msg = "you need to go to school";
                      break;

                  default:
                      throw new ArgumentException(
                          "Unrecognized property: " + property);
              }
              return msg;
          }


      }

      #endregion
    }
}
