﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace WpfApplication10
{
    public  class Person :INotifyPropertyChanged, IDataErrorInfo
    {
        string name = string.Empty;
        public string Name
        {
            get { return name; }
            set { name = value;
            NotifyPropertyChanged("Name");
            }
        }
        Job occupation = new Job();
        public Job Occupation
        {
            get { return occupation;}
            set { occupation = value;
            NotifyPropertyChanged("Occupation");
            }
        }
        Education ed = new Education();
        public Education ED
        {
            get { return ed; }
            set { ed = value;
            NotifyPropertyChanged("Ed");
            }
        }

        public void ValidateProperties()
        {
            NotifyPropertyChanged("Name");
            NotifyPropertyChanged("Occupation");
            NotifyPropertyChanged("ED");
           
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


        #endregion

        #region IDataErrorInfo Members

        //public string Error
        //{
        //    get { throw new NotImplementedException(); }
        //}

        //public string this[string columnName]
        //{
        //    get { throw new NotImplementedException(); }
        //}

        public string Error
        {
            // get { throw new NotImplementedException(); }

            get { return null; }

        }

        public string this[string property]
        {
            //get { throw new NotImplementedException(); }
            get
              {
                string msg = null;
                switch (property)
                {
                    case "Name":
                        if ((this.Name == string.Empty) || (this.Name == null))
                        {
                            msg = "you need a name son ";
                        }
                       
                        break;
                    case "Occupation":
                        if (Occupation == null)
                        {
                            msg = " you need an occupation";
                            

                        }
                        break;
                    case "ED":
                        if (ED == null)
                        {
                            msg = "you need an education ";
                            
                        }
                        break;
                    default:
                        throw new ArgumentException(
                            "Unrecognized property: " + property);
                }
                return msg;
            }


        }

        #endregion
    }
}
